"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
// Wait for stop function to return true
// By default it will wait for 500ms until reject
function waitFor(stop, timeoutMs = 500) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve, reject) => {
            let timeoutId;
            const intervalId = setInterval(() => {
                timeoutId = timeoutId || setTimeout(() => {
                    clearInterval(intervalId);
                    clearTimeout(timeoutId);
                    reject(`waitFor timeout (${timeoutMs}ms)`);
                }, timeoutMs);
                if (stop()) {
                    clearInterval(intervalId);
                    clearTimeout(timeoutId);
                    resolve(true);
                }
            }, 50);
        });
    });
}
exports.default = waitFor;
//# sourceMappingURL=waitFor.js.map